#include "eigenbox.h"

apop_data *query_data(){
    apop_db_open("data-census.db");
    return apop_query_to_data(" select postcode as row_names, \n\
                        m_per_100_f, population/1e6 as population, median_age \n\
                        from geography, income,demos,postcodes \n\
                        where income.sumlevel= '040' \n\
                        and geography.geo_id = demos.geo_id  \n\
                        and income.geo_name = postcodes.state  \n\
                        and geography.geo_id = income.geo_id ");
}

void show_projection(gsl_matrix *pc_space, apop_data *data){
    apop_opts.output_type = 'p';
    apop_opts.output_pipe = stderr;
    fprintf(stderr,"The eigenvectors:\n");
    apop_matrix_print(pc_space, NULL);
    apop_data *projected = apop_dot(data, apop_matrix_to_data(pc_space), 0, 0);
    printf("plot '-' using 2:3:1 with labels\n");
    apop_data_show(projected);
}
