#include <apop.h>
gsl_rng *r;

void jitter(double *in){
    *in += (gsl_rng_uniform(r) - 0.5)/10; 
}

int main(){
    apop_db_open("data-tattoo.db");
    gsl_matrix *m = apop_query_to_matrix("select  \
                tattoos.'ct tattoos ever had' ct, \
                tattoos.'year of birth'+1900  yr  \
                from tattoos                      \
                where  yr < 1997 and ct+0.0 < 10");
    r = apop_rng_alloc(0);
    apop_matrix_apply_all(m, jitter);
    printf("set key off; set xlabel 'tattoos';  \n\
           set ylabel 'birth year';            \n\
           plot '-' pointtype 6\n");
    apop_matrix_show(m);
}
