#include "sinsq.c"

void do_search(int number, char *name, char *trace){
  apop_model    *out;
  double        p[] = {0};
  double        result;
  char          *outf;
    Apop_settings_add_group(&sin_sq_model, apop_mle,  &sin_sq_model);
    Apop_settings_add(&sin_sq_model, apop_mle, starting_pt, p);
    Apop_settings_add(&sin_sq_model, apop_mle, method, number);
    Apop_settings_add(&sin_sq_model, apop_mle, tolerance, 1e-4);
    Apop_settings_add(&sin_sq_model, apop_mle, mu_t, 1.25);
    asprintf(&outf, "localmax_out/%s.gplot", trace);
    Apop_settings_add(&sin_sq_model, apop_mle, trace_path, outf);
    out = apop_estimate(NULL, sin_sq_model);
    result          = gsl_vector_get(out->parameters->vector, 0);
    printf("The %s algorithm found %g.\n", name, result);
    Apop_settings_rm_group(&sin_sq_model, apop_mle);
}

int main(){
    system ("mkdir -p localmax_out; rm -f localmax_out/*.gplot");
    apop_opts.verbose ++;
    do_search(APOP_SIMPLEX_NM, "N-M Simplex", "simplex");
    do_search(APOP_CG_FR, "F-R Conjugate gradient", "fr");
    do_search(APOP_SIMAN, "Simulated annealing", "siman");
    do_search(APOP_RF_NEWTON, "Root-finding", "root");
    fflush(NULL);
    system("sed -i \"1iplot '-'\" localmax_out/*.gplot");
}
